<?php
class WatuPROACBridge {
   static function main() {
   	  global $wpdb;
   	  
   	  $tab = empty($_GET['tab']) ? 'main' : sanitize_text_field($_GET['tab']);
   	  if($tab == 'log') return self :: log();
   	  
   	  // save ActiveCampaign API key and password
   	  if(!empty($_POST['set_key']) and check_admin_referer('watuproac_settings')) {
			  $double_optin = empty($_POST['no_optin']) ? 0 : 1;   	  	
   	  	
   	  	  update_option('watuproac_api_url', esc_url_raw($_POST['api_url']));
   	  	  update_option('watuproac_api_key', sanitize_text_field($_POST['api_key']));
   	  	 // update_option('watuproac_no_optin', $double_optin);
   	  }
   	  $api_key = get_option('watuproac_api_key');
   	  $api_url = $url = get_option('watuproac_api_url');
   	  
   	  // select exams
   	  $exams = $wpdb->get_results("SELECT * FROM ".WATUPRO_EXAMS." ORDER BY name");
   	  
   	  if(!empty($api_key) and !empty($url)) {
   	  
	   	  // select mailing lists from AC
	   	 	$json_result = wp_remote_get($url.'/api/3/lists?limit=100', array(
					'timeout' => 45,
				    'headers'     => array('Api-Token' => $api_key),
			    ));		
			    	
				if( is_wp_error( $json_result  ) ) {
				    echo $json_result->get_error_message();
				    $result = '';
				}
				else $result = json_decode($json_result['body']);
				//print_r($json_result);
				$lists = @$result->lists;
				//print_r($lists);
				   	  
	   	  // add/edit/delete relation
	   	  if(!empty($_POST['add']) and check_admin_referer('watuproac_rule')) {
					// no duplicates		
					$exists = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WATUPROAC_RELATIONS."
						WHERE exam_id=%d AND list_id=%d AND grade_id=%d", intval($_POST['exam_id']), intval($_POST['list_id']), intval($_POST['grade_id'])));   	  	
	   	  	
	   	  	if(!$exists) {
						$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROAC_RELATIONS." SET 
							exam_id = %d, list_id=%d, grade_id=%d", intval($_POST['exam_id']), intval($_POST['list_id']), intval($_POST['grade_id'])));
						}   	  
	   	  }
	   
	   		if(!empty($_POST['save']) and check_admin_referer('watuproac_rule')) {
					$wpdb->query($wpdb->prepare("UPDATE ".WATUPROAC_RELATIONS." SET 
						exam_id = %d, list_id=%d, grade_id=%d WHERE id=%d", 
						intval($_POST['exam_id']), intval($_POST['list_id']), intval($_POST['grade_id']), $_POST['id']));   	  
	   	  }
	   	  
				if(!empty($_POST['del']) and check_admin_referer('watuproac_rule')) {
					$wpdb->query($wpdb->prepare("DELETE FROM ".WATUPROAC_RELATIONS." WHERE id=%d", intval($_POST['id'])));
				}   	  
	   	  
	   	  // select existing relations
	   	  $relations = $wpdb->get_results("SELECT * FROM ".WATUPROAC_RELATIONS." ORDER BY id");
	   	  
	   	  // select all non-category grades and match them to exams and relations
	   	  $grades = $wpdb->get_results("SELECT * FROM ".WATUPRO_GRADES." WHERE cat_id=0 ORDER BY gtitle");
	   	  
	   	  foreach($exams as $cnt=>$exam) {
	   	  	  $exam_grades = array();
	   	  	  foreach($grades as $grade) {
	   	  	  	if($grade->exam_id == $exam->ID) $exam_grades[] = $grade;
				  }
				  
				  $exams[$cnt]->grades = $exam_grades;
	   	  }
	   	  
	   	  foreach($relations as $cnt=>$relation) {
	   	  	  $rel_grades = array();
	   	  	  foreach($grades as $grade) {
	   	  	  	if($grade->exam_id == $relation->exam_id) $rel_grades[] = $grade;
				  }
				  
				  $relations[$cnt]->grades = $rel_grades;
	   	  }
	    } // end if url and key provided	  
   	     	  
   	  include(WATUPROAC_PATH."/views/main.html.php");
   }
   
   // show log
   static function log() {
   	global $wpdb;
   	
   	$date_format = get_option('date_format');
   	$time_format = get_option('time_format');
   	
   	$logs = $wpdb->get_results("SELECT tL.*, tE.name as quiz, tG.gtitle as grade 
   	FROM ".WATUPROAC_LOGS." tL JOIN ".WATUPRO_EXAMS." tE ON tE.ID = tL.exam_id
   	LEFT JOIN ".WATUPRO_GRADES." tG ON tG.ID =tL.grade_id
   	ORDER BY tL.id DESC LIMIT 100");
   	include(WATUPROAC_PATH."/views/log.html.php");
   }

	 // actually subscribe the user
	 static function complete_exam($taking_id) {
	 	  global $wpdb;
	 	  
	 	 // echo "HERE BRIDGE 1";
	 	 
	 	  // select taking		
	 	  $taking = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 	
	 	  	WHERE ID=%d", $taking_id));
	 	  	
	 	  // if email not available, return false
			if(empty($taking->user_id) and empty($taking->email)) return false;
			
	 	  // see if there are any relations for this exam ID
	 	  $relations = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WATUPROAC_RELATIONS." 
		 	  WHERE exam_id=%d", $taking->exam_id));
		 	  
		 	if(!sizeof($relations)) return false;  
		 	 // echo "HERE BRIDGE 2";
	
		$email = $taking->email;
		$name = $taking->name;
		if(empty($email)) {
			$user = get_userdata($taking->user_id);
      	$email = $user->user_email;
      	$name = $user->display_name;
		}
		
		// name still empty? Default to guest although that's not a great idea
		if(empty($name)) $name = 'Guest';
      
      // add to MailChimp
      $api_key = get_option('watuproac_api_key');
   	$url = get_option('watuproac_api_url');
   	
   	$status = 1;
   	
   	// select mailing lists from mailchimp
   	foreach($relations as $relation) {
		  // check grade
		  if(!empty($relation->grade_id) and $relation->grade_id != $taking->grade_id) continue;
			
			// break $name into $fname and $lname if possible. If no space, $fname = $name
			if(strstr($name, ' ')) {
				$parts = explode(' ', $name);
				$fname = $parts[0];
				array_shift($parts);
				$lname = implode(' ', $parts);
			}
			else {
				$fname = $name;
				$lname = '';
			}
			
			// create contact
			$contact = array(
					'contact' => array(
							    	'email' => $email,
							    	'firstName' => $fname,
							    	'lastName' => $lname					
								)
					);			
					
					//echo json_encode($contact);
			
			$args = array(
				'method' => 'POST',
			 	'headers' => array('Api-Token' => $api_key),
				'body' => json_encode($contact)
			);
			
			
			$response = wp_remote_post( $url.'/api/3/contact/sync', $args );
			
			//print_r($response);
						
			if ( $response['response']['code'] == 201 or $response['response']['code'] == 200) {
				
				$contact = json_decode($response['body']);
				
				// if result is OK, subscribe them to the list				
				$contact_list = array(
					'contactList' => array(
							    	'list' => $relation->list_id,
							    	'contact' => $contact->contact->id,
							    	'status' => 1					
								)
					);			
					
				$args = array(
					'method' => 'POST',
				 	'headers' => array('Api-Token' => $api_key),
					'body' => json_encode($contact_list)
				);
				
				$response = wp_remote_post( $url.'/api/3/contactLists', $args );
				
				$result = '<b>' . $response['response']['code'] . ': '.$response['response']['message'].'</b> ';
				
				// log response
				$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROAC_LOGS." SET 
				exam_id=%d, list_id=%s, grade_id=%d, ac_response=%s, datetime=%s",
				$taking->exam_id, $relation->list_id, $taking->grade_id, $result, current_time('mysql')));
				
			} else {
				//echo '<b>' . $response['response']['code'] . $body->title . ':</b> ' . $body->detail;
				$result = '<b>' . $response['response']['code'] . ': '.$response['response']['message'].'</b> ';
				
				// log response
				$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROAC_LOGS." SET 
				exam_id=%d, list_id=%s, grade_id=%d, ac_response=%s, datetime=%s",
				$taking->exam_id, $relation->list_id, $taking->grade_id, $result, current_time('mysql')));
			}
		
			
		} // end foreach relation	
   } // end complete exam
}