<?php
// main model containing general config and UI functions
class WatuPROAC {
   static function install() {
   	global $wpdb;	
   	$wpdb -> show_errors();
   	
   	self::init();
	   
    // relations bewteen completed exams and mailing lists. 
    // For now not depending on exam result but place the field for later use
    if($wpdb->get_var("SHOW TABLES LIKE '".WATUPROAC_RELATIONS."'") != WATUPROAC_RELATIONS) {  
        $sql = "CREATE TABLE `".WATUPROAC_RELATIONS."` (
				id int(11) unsigned NOT NULL auto_increment PRIMARY KEY,
				exam_id int(11) unsigned NOT NULL default '0',
				list_id INT UNSIGNED NOT NULL DEFAULT 0,
				grade_id int(11) unsigned NOT NULL default '0'
			) CHARACTER SET utf8;";
        $wpdb->query($sql);         
    	}
	
	
	 // Log for each attempt to store contact in mailChimp
    if($wpdb->get_var("SHOW TABLES LIKE '".WATUPROAC_LOGS."'") != WATUPROAC_LOGS) {  
        $sql = "CREATE TABLE `".WATUPROAC_LOGS."` (
				id int(11) unsigned NOT NULL auto_increment PRIMARY KEY,
				exam_id int(11) unsigned NOT NULL default '0',
				list_id VARCHAR(100) NOT NULL DEFAULT '',
				email VARCHAR(100) NOT NULL DEFAULT '',
				grade_id int(11) unsigned NOT NULL default '0',
				ac_response TEXT,
				`datetime` DATETIME
			) CHARACTER SET utf8;";
        $wpdb->query($sql);         
    	}
	}	// end install()   
   
   // main menu
   static function menu() {
   	add_submenu_page('watupro_exams', __('Bridge to ActiveCampaign', 'watuprochimp'), __('Bridge to ActiveCampaign', 'watuprochimp'), 'manage_options', 
   		'watuproac', array('WatuPROACBridge','main'));	
	}
	
	// CSS and JS
	static function scripts() {   
   	wp_enqueue_script('jquery');
	}
	
	// initialization
	static function init() {
		global $wpdb;
		load_plugin_textdomain( 'watuprochimp' );
		define('WATUPROAC_RELATIONS', $wpdb->prefix.'watuproac_relations');
		define('WATUPROAC_LOGS', $wpdb->prefix.'watuproac_logs');
		
		add_action('watupro_completed_exam', array('WatuPROACBridge', 'complete_exam'));
	}	
}