<h2 class="nav-tab-wrapper">
	<a class='nav-tab nav-tab-active' href="admin.php?page=watuproac"><?php _e('Settings', 'watuproac')?></a>
	<a class='nav-tab' href="admin.php?page=watuproac&tab=log"><?php _e('Log', 'watuproac')?></a>
</h2>

<div class="wrap">
	<h1><?php _e('WatuPRO to ActiveCampaign Bridge', 'watuproac')?></h1>
	
	<p><?php _e('This bridge lets you automatically subscribe users who take your exams into select list in ActiveCampaign. You need to know your ActiveCampaign API key and API URL.', 'watuproac')?></p>
	
	<p><?php _e('Note that in order to have quiz taker subscribed you need their email address. So this will work the user is logged or (for non-logged in users) when you have selected "Send email to the user with their results" in the exam settings page.','watuproac')?> </p>
	
	<form method="post">
		<p>Your ActiveCampaign API Key: <input type="text" name="api_key" value="<?php echo $api_key?>" size="60"> <br />
		Your ActiveCampaign API URL: <input type="text" name="api_url" value="<?php echo $api_url?>" size="60"> <br />
		
		<input type="submit" name="set_key" value="<?php _e('Save Settings', 'watuproac');?>"</p>
		<?php wp_nonce_field('watuproac_settings');?>
	</form> 
	
	<?php if(empty($api_key)):?>
		<p><b><?php _e('You will not be able to add any rules until you enter your ActiveCampaign API Key and URL.', 'watuproac');?></b></p>
	<?php return;
	endif;
	if(!empty($result->error) or empty($result->total)):?>
		<p><?php _e("We couldn't retrieve any mailing lists from your ActiveCampaign account.", 'watuproac');?></p>
		<?php if(!empty($result->error)):?>
			<p><?php _e("We got this error from ActiveCampaign:", 'watuproac');?> <b><?php echo $result->error;?></b></p>
		<?php endif;?>
		<p><a href="#" onclick="jQuery('#mailChimpResponse').toggle();return false;"><?php _e('Raw ActiveCampaign response (debug)', 'watuproac');?></a></p>
		<div style="display:none;" id="mailChimpResponse"><?php print_r($json_result);?></div>
	<?php endif;?>
   
   <h2><?php _e('Add New Rule', 'watuproac')?></h2>	  
	  
	 <form method="post">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuproac')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector');">
	 			<option value=""><?php _e('- Select quiz -', 'watuproac');?></option>
	 			<?php foreach($exams as $exam):?>
	 				<option value="<?php echo $exam->ID?>"><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
				
				<?php _e('achieving the following grade:', 'watuproac')?>
				<span id="wbbGradeSelector">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuproac');?></option>
					   <?php foreach($exams[0]->grades as $grade):?>
					   	<option value="<?php echo $grade->ID?>"><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>				
				
				 			
	 			<?php _e('subscribe them to mailing list','watuproac')?> 
	 			<select name="list_id">
	 				<option value=""><?php _e('- Select list -', 'watuproac');?></option>
	 				<?php foreach($lists as $list):?>
	 					<option value="<?php echo $list->id?>"><?php echo stripslashes($list->name);?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<input type="submit" name="add" value="<?php _e('Add Rule', 'watuproac')?>">
	 	</div>
	 	<?php wp_nonce_field('watuproac_rule');?>
	 </form> 
	 
	 <h2><?php _e('Manage Existing Rules', 'watuproac')?></h2>
	 <?php if(count($relations)):?>
	 	<?php foreach($relations as $relation):?>
	 	<form method="post">
	 	<input type="hidden" name="id" value="<?php echo $relation->id?>">
	 	<input type="hidden" name="del" value="0">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuproac')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector<?php echo $relation->id?>');">
	 			<option value=""><?php _e('- Select quiz -', 'watuproac');?></option>
	 			<?php foreach($exams as $exam):
	 				$selected = ($exam->ID == $relation->exam_id) ? " selected" : "";?>
	 				<option value="<?php echo $exam->ID?>"<?php echo $selected?>><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
	 			
				<?php _e('achieving the following grade:', 'watuproac')?>
				<span id="wbbGradeSelector<?php echo $relation->id?>">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuproac');?></option>
					   <?php foreach($relation->grades as $grade):
					   	$selected = ($grade->ID == $relation->grade_id) ? " selected" : "";?>
					   	<option value="<?php echo $grade->ID?>"<?php echo $selected?>><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>			
					 			
	 			<?php _e('subscribe them to mailing list','watuproac')?> 
	 			<select name="list_id">
	 			<option value=""><?php _e('- Select list -', 'watuproac');?></option>
	 				<?php foreach($lists as $list):
	 					$selected = ($list->id == $relation->list_id) ? " selected" : "";?>
	 					<option value="<?php echo $list->id?>"<?php echo $selected?>><?php echo stripslashes($list->name);?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<input type="submit" name="save" value="<?php _e('Save Rule', 'watuproac')?>">
	 			<input type="button" value="<?php _e('Delete Rule', 'watuprochimp')?>" onclick="WCConfirmDelete(this.form);">
	 	</div>
	 	<?php wp_nonce_field('watuproac_rule');?>
	 </form> 
	 	<?php endforeach;?>
	 <?php else:?>
	 <p><?php _e('You have not created any rules yet.', 'watuproac');?></p>	
	 <?php endif;?>
</div>

<script type="text/javascript" >
function WCConfirmDelete(frm) {
		if(confirm("<?php _e('Are you sure?', 'watuproac')?>")) {
			frm.del.value=1;
			frm.submit();
		}
}

function wcChangeQuiz(quizID, selectorID) {
	// array containing all grades by exams
	var grades = {<?php foreach($exams as $exam): echo $exam->ID.' : {';
			foreach($exam->grades as $grade):
				echo $grade->ID .' : "'.$grade->gtitle.'",';
			endforeach;
		echo '},';
	endforeach;?>};
	
	// construct the new HTML
	var newHTML = '<select name="grade_id">';
	newHTML += "<option value='0'><?php _e('- Any grade -', 'watuproac');?></option>";
	jQuery.each(grades, function(i, obj){
		if(i == quizID) {
			jQuery.each(obj, function(j, grade) {
				newHTML += "<option value=" + j + ">" + grade + "</option>\n";
			}); // end each grade
		}
	});
	newHTML += '</select>'; 
	
	jQuery('#'+selectorID).html(newHTML);
}
</script>